#include <assert.h>
#include <stdlib.h>
#include <string.h>

extern "C" {
    // char *html_entities (char *raw_text);
    long *html_entities (char *raw_text, char *ret_text, long ret_size);
           }

/* This function converts the characters < > & and quotation marks
 * into their html entities, which are &lt; &gt; &amp; and &quot; */
char *html_entities (char *raw_text)
{
     int raw_length;
     int out_length;
     char *out_text;
     char new_char[2];
     int i;

    // assert (raw_text != (char *)NULL );
     
     raw_length = strlen (raw_text);
     
     if (raw_length == 0)
     {
      out_text = malloc(sizeof(char));
      out_text[0] = '\0';
     } 
     else
     {
      /* Count the number of characters needed for the output
       * string */
      out_length = 0;
      for (i = 0; i < raw_length; i++)
      {
           switch (raw_text[i]) {
           case '<':
           case '>':
            out_length += 4;
            break;
           case '&':
            out_length += 5;
            break;
           case '"':
            out_length += 6;
            break;
           default:
            out_length += 1;
           }
      }

      /* Convert some tags into their HTML entities */
      out_text = (char *) malloc ((out_length + 1) * sizeof(char));
      out_text[0] = '\0';
      for (i = 0; i < raw_length; i++)
      {
           switch (raw_text[i]) {
           case '<':
            strcat(out_text, "&lt;");
            break;
           case '>':
            strcat(out_text, "&gt;");
            break;
           case '&':
            strcat(out_text, "&amp;");
            break;
           case '"':
            strcat (out_text, "&quot;");
            break;
           default:
            new_char[0] = raw_text[i];
            new_char[1] = '\0';
            strcat (out_text, new_char);
            break;
           }
      }
     }

     // return (out_text);

    //Carl: I changed to a *out string
    if (out_length <= ret_size and out_length > 0)
    {
        strcpy( ret_text,out_text)
    }
    // long *html_entities (char *raw_text, char *out_text, long out_size);


     return (out_length);
}
