    program

!in Project
!_ABCDllMode_    equate(0)
!_ABCLinkMode_   equate(1)


    !Adding some C code to your Clarion App
    !1. I downloaded and saved the RC4.h and RC4.C files
    !2. I modified the .h file to wrap the functions in  extern "C" { }
    !   or you'll get a linker due to the name mangling
    !        Example
    !        #ifdef __cplusplus       // Carl added or get name mangle problem
    !        extern "C" {
    !        #endif
    !           function prototypes
    !        #ifdef __cplusplus       // Carl added or get name mangle problem
    !        }
    !        #endif
    !               extern "C" {
    !                    void rc4_setup( struct rc4_state *s, unsigned char *key,  int length );
    !                          };
    !3. Prototyped the C functions in Clarion and made the NAME('_xxx') start with an underscore, the Extern C standard
    !4. Added RAW since I would be passing strings
    !5. Since the C code is being compiled by Clarion the Pascal attribute is not needed ?
    !6. I prototyped other structures/equates in Clarion needed to pass to the C functions
    !7. I added the .C source moudle to my project, or use a dummy CLASS LINK to include it
    !
    !Other questions for completess
    !what about if you need to include some standard C library stuff? e.g. #include <string.h> #include <stdio.h>
    !Ok I had bought the old IDE and have the H files in F:\c\inc

    !The biggest part was trying to figure out how to use these two functions
    !Two damn functions, here's what I figured out
    !rc4_setup(State,Key,Length) is called and you pass it the Key you'll use for Encrypt and Decrypt
    !               It sets up everything it needs in rc4_state_type
    !rc4_crypt(State,Data,Length) does encryption AND decryption and returns the modified Data
    !               Is is an XOR algorithm so it goes both ways
    !               The trick is you must start with the same rc4_state
    !Example Encryption:
    !   rc4_setup( RCState, 'Hello', 5 )
    !   rc4_crypt( RCState, Data2Encrypt, size(Data2Encrypt) )
    !Example Decryption:
    !   rc4_setup( RCState, 'Hello', 5 )    !If you are doing this right after the above code (to test) do NOT skip this step, will not work
    !   rc4_crypt( RCState, EncryptedData, size(Data2Encrypt) )


    !Pages of interest
    !   http://www.cr0.net:8040/code/crypto/            Where the code came from
    !   http://www.l3.u-net.com/articles/art3.htm       Using C in Clarion
    !   http://en.wikipedia.org/wiki/RC4_(cipher)       Discussion of RC4, what is is and how it works


    include 'rc4_h_inc.inc'

RC4State    like(rc4_state_type)
RCKey       string('KingsPlayChessOnFridaysGenerally')
RCdata      string(256)
RCorig      string(256)
LenD         long


Test8Key     string(8)              !Source provided some tests, just do the 8 byte ones to do it simply
Test8Data    string(8)
Test8Out     string(8)

testsMsg     string(1000)
    code

    !================================ C Code Tests
    !Test give in C Source
    !They provided what the encrypted Output value is suppose to be
    !I only did the ones with 8 byte values
    testsMsg='Tests provided with C source'
    !Test 1
    Test8Key ='<01h,23h,45h,67h,89h,0abh,0cdh,0efh>'        !Use this Key
    Test8Data=Test8Key                                      !To encrypt this data (Yes first test is to encrypt the Key value)
    Test8Out ='<75h,0b7h,87h,80h,99h,0e0h,0c5h,96h,00h>'    !output should be this

    !Must Setup the RC4 state again to do the Decypt
    rc4_setup( RC4State, Test8Key,  size(Test8Key) )
    rc4_crypt( RC4State, Test8Data, size(Test8Data) )
    testsMsg=clip(testsMsg) & '|test 1 ' & choose(Test8Data=Test8Out,'Passed','Failed')

    !Test 2
    Test8Data='<0,0,0,0,0,0,0,0,0ffh>'                              !Test 2 uses Same Key different Data
    Test8Out ='<074h,094h,0c2h,0e7h,010h,04bh,008h,079h,000>'
    clear(RC4State)
    rc4_setup( RC4State, Test8Key,  size(Test8Key) )
    rc4_crypt( RC4State, Test8Data, size(Test8Data) )
    testsMsg=clip(testsMsg) & '|test 2 ' & choose(Test8Data=Test8Out,'Passed','Failed')

    !Test 3
    Test8Key =ALL('<0>')                                    !Use this Key {8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}
    Test8Data='<0,0,0,0,0,0,0,0,0ffh>'                      !To encrypt this data (Yes first test is to encrypt the Key value)
    Test8Out ='<0deh,018h,089h,041h,0a3h,037h,05dh,03ah,000>'    !output should be this
    clear(RC4State)
    rc4_setup( RC4State, Test8Key,  size(Test8Key) )
    rc4_crypt( RC4State, Test8Data, size(Test8Data) )
    testsMsg=clip(testsMsg) & '|test 3 ' & choose(Test8Data=Test8Out,'Passed','Failed')  

    Message(testsMsg)


    ! test encrypt then decrypt

    clear(RC4State)
    rc4_setup(RC4State, RCKey, size(RCKey))
    RCdata='Little Mary took her skates upon the ice to frisk, wasn''t she a litte fool *'
    RCorig=RCdata
    LenD = len(clip(RCdata))
    rc4_crypt(RC4State, RCdata, LenD)

    !message('Encrypt:|' & clip(RCdata) & '||Original:|' & clip(RCorig)  )

    !MUST do the Setup again so vector is in the initial State
    rc4_setup(RC4State, RCKey, size(RCKey) )
    rc4_crypt(RC4State, RCdata, LenD )

    message('Decrypt:|' & clip(RCdata) & '||Original:|' & clip(RCorig) &'||' & choose(RCdata=RCorig,'Passed','Failed') )



    rc4_setup( RC4State, 'Hello', 5)
    RCdata='test using STRING key'
    RCorig=RCdata
    LenD = len(clip(RCdata))
    rc4_crypt( RC4State, RCdata, LenD )

    rc4_setup( RC4State, 'Hello', 5)            !MUST do the Setup again so vector is in the initial State
    rc4_crypt( RC4State, RCdata, LenD )
    if RCdata<>RCorig then
        message('failed on TEST: ' &  RCorig)
    end







    omit('*** test code in C ***')

#ifdef TEST

#include <string.h>
#include <stdio.h>

/*
 * ARC4 tests vectors from OpenSSL (crypto/rc4/rc4test.c)
 */

static unsigned char keys[7][30]={
        {8,0x01,0x23,0x45,0x67,0x89,0xab,0xcd,0xef},    1
        {8,0x01,0x23,0x45,0x67,0x89,0xab,0xcd,0xef},    2
        {8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    3
        {4,0xef,0x01,0x23,0x45},                        4
        {8,0x01,0x23,0x45,0x67,0x89,0xab,0xcd,0xef},    5
        {4,0xef,0x01,0x23,0x45},                        6
        };

static unsigned char data_len[7]={8,8,8,20,28,10};
static unsigned char data[7][30]={
        {0x01,0x23,0x45,0x67,0x89,0xab,0xcd,0xef,0xff},  1
        {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff},  2
        {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff},  3
        {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,        4
           0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
           0x00,0x00,0x00,0x00,0xff},
        {0x12,0x34,0x56,0x78,0x9A,0xBC,0xDE,0xF0,        5
           0x12,0x34,0x56,0x78,0x9A,0xBC,0xDE,0xF0,
           0x12,0x34,0x56,0x78,0x9A,0xBC,0xDE,0xF0,
           0x12,0x34,0x56,0x78,0xff},
        {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff}, 6
        {0},
        };

static unsigned char output[7][30]={
        {0x75,0xb7,0x87,0x80,0x99,0xe0,0xc5,0x96,0x00},
        {0x74,0x94,0xc2,0xe7,0x10,0x4b,0x08,0x79,0x00},
        {0xde,0x18,0x89,0x41,0xa3,0x37,0x5d,0x3a,0x00},
        {0xd6,0xa1,0x41,0xa7,0xec,0x3c,0x38,0xdf,
         0xbd,0x61,0x5a,0x11,0x62,0xe1,0xc7,0xba,
         0x36,0xb6,0x78,0x58,0x00},
        {0x66,0xa0,0x94,0x9f,0x8a,0xf7,0xd6,0x89,
         0x1f,0x7f,0x83,0x2b,0xa8,0x33,0xc0,0x0c,
         0x89,0x2e,0xbe,0x30,0x14,0x3c,0xe2,0x87,
         0x40,0x01,0x1e,0xcf,0x00},
        {0xd6,0xa1,0x41,0xa7,0xec,0x3c,0x38,0xdf,0xbd,0x61,0x00},
        {0},
        };

int main( void )
{
    int i;
    struct rc4_state s;
    unsigned char buffer[30];

    printf( "\n RC4 Validation Tests:\n\n" );

    for( i = 0; i < 6; i++ )
    {
        printf( " Test %d ", i + 1 );

        memcpy( buffer, data[i], data_len[i] );

        rc4_setup( &s, &keys[i][1], keys[i][0] );
        rc4_crypt( &s, buffer, data_len[i] );

        if( memcmp( buffer, output[i], data_len[i] ) )
        {
            printf( "failed!\n" );
            return( 1 );
        }

        printf( "passed.\n" );
    }

    printf( "\n" );

    return( 0 );
}

#endif

    endomit('*** test code in C ***')

