!========================================
! Copyright  2005 by Carl Barnes
!========================================

!Be nice to have Hex2string and String2Hex functions since I need to use the encryted data as ASCII sometimes

  MEMBER

! OMIT('*endomit*',_C55_)
!_ABCDllMode_    EQUATE(0)
!_ABCLinkMode_   EQUATE(1)
! *endomit*

  INCLUDE('CBRC4cls.inc'),ONCE

  Include 'Rc4_h_inc.Inc'

! Severity of error, use ABC Codes here
Level:Benign   EQUATE(0)
Level:User     EQUATE(1)

  MAP
DB              procedure(string msg)

      MODULE('Windows')
        OutputDebugString(*CSTRING Msg),PASCAL,RAW,NAME('OutputDebugStringA')
      END

  END

!ByteCast    EQUATE(0FF000000h)                  !For (unsigned char) cast, assumes Little Endian...like that's going to change for me
ByteCast    EQUATE(0FFh)                  !For (unsigned char) cast, assumes Little Endian...like that's going to change for me

!state     group,type        !int x, y, m[256];
!x            long            self.state.x
!y            long            self.state.y
!m            long,dim(256)   self.state.m
!          end

!this would probably run faster as two functions that pass in the state

CBRC4Cls.setup           procedure(string KeyString)        !So can just pass KeyString w/o declaring String
    code
    self.setup(KeyString)
    return
!---------------
CBRC4Cls.setup           procedure(*string KeyString, long KeyLen=0)
    code
    IF ~KeyLen THEN KeyLen=len(clip(KeyString)).
    DB('CBRC4Cls.setup =top=  KeyLen=' & KeyLen & '  KeyString=' & KeyString )
    rc4_setup( address(self.state), address(KeyString),  KeyLen )
    return

!----------------
CBRC4Cls.crypt  Procedure(*string Data, long DataLen )
    code
    DB('CBRC4Cls.crypt =top=  DataLen=' & DataLen & '  Data=' & Data )
    rc4_crypt( address(self.state), address(Data), DataLen )

    return

!!=====================================================================================
DB      procedure(string msg)
cmsg    cstring(512)
    code
    cmsg='CBRC4Cls - ' & clip(msg) & '<13,10>'
    outputdebugstring(cmsg)
    return

!=========================

!ByteToHex PROCEDURE(BYTE in)!,STRING (2)
!Hex       STRING('0123456789ABCDEF')
!  CODE
!  RETURN HEX[BSHIFT(in, -4) + 1] & HEX[BAND(in, 0FH) + 1]


!take 'Clarion' and return '436C6172696F6E'
CBRC4Cls.StringToHex    PROCEDURE(*STRING In, *STRING OutStr)!,LONG,PROC
InLen   LONG,AUTO
ByteIn  LONG,AUTO
bVal    LONG,AUTO
ByteOut LONG(0)
Hex     STRING('0123456789ABCDEF')
    CODE
    CLEAR(OutStr)
    InLen = LEN(CLIP(IN))
    IF ~InLen or InLen * 2 > SIZE(OutStr) THEN RETURN 0.
    LOOP ByteIn = 1 TO InLen
         bVal = VAL(In[ByteIn])
         ByteOut += 1 ; OutStr[ ByteOut ] = HEX[BSHIFT(bVal, -4) + 1]
         ByteOut += 1 ; OutStr[ ByteOut ] = HEX[BAND(bVal, 0FH) + 1]
    END
    RETURN ByteOut


! Take '436c6172696f6e' and make 'Clarion'
CBRC4Cls.HexToString  PROCEDURE(*STRING In, *STRING OutStr, <*LONG ErrorPos>)!,LONG,PROC  PROCEDURE(STRING In, <*LONG ErrorPos>)!,STRING
InLen   LONG,AUTO
ByteIn  LONG,AUTO
InVal   BYTE,AUTO
InHex   LONG,AUTO

OutHex  LONG(0)
ByteOut LONG(0)
    CODE
    InLen = LEN(CLIP(IN))
    IF ~InLen or InLen / 2 > SIZE(OutStr) THEN RETURN 0.
    LOOP ByteIn = 1 TO InLen
         InVal = VAL(In[ByteIn])
         CASE InVal
         OF 30h TO 39h ; InHex = InVal - 30h       !1-9
         OF 41h TO 46h ; InHex = InVal - 41h + 10  !A-F
         OF 61h TO 66h ; InHex = InVal - 61h + 10  !a-f
         ELSE   !Not a hex digit
            OutHex = 1  !trips error below
            BREAK
         END
         OutHex = BSHIFT(OutHex,+4) + InHex
         IF ~BAND(ByteIn,1b)  !aka  ByteIn % 2 = 0  did not really test which is cheaper
            ByteOut += 1
            OutStr[ByteOut] = CHR(OutHex)
            OutHex = 0
         END
    END
    IF OutHex                                   !Odd hex digit leftover
       IF ~OMITTED(2) THEN ErrorPos=ByteIn.
       ByteOut = 0  !tell caller we failed
    END
    RETURN ByteOut

