/* Release 3.00 */

/*-------------------------------------------------------------------------*
*                                                                          *
*  limits.h -  Value ranges for common data types.             *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/
// no work  #pragma option(pre_proc=>on)    // writes a .i file with the preprocessor output
// no work  #pragma option(incl_cmt=>on)    // used with pre_proc writes comments to .i file

#ifndef _LIMITS_INC_
#define _LIMITS_INC_

#define CHAR_BIT              8
#ifdef  __CHAR_UNSIGNED__
#define CHAR_MIN                  0
#define CHAR_MAX                255
#else
#define CHAR_MIN             (-128)
#define CHAR_MAX                127
#endif
#define MB_LEN_MAX                1
#define SCHAR_MAX               127
#define SCHAR_MIN            (-128)
#define UCHAR_MAX               255
#define SHRT_MAX              32767
#define SHRT_MIN         (-32767-1)
#define USHRT_MAX            65535U
//#define INT_MAX               32767  //Carl changed see below
//#define INT_MIN          (-32767-1)
//#define UINT_MAX            0xFFFFU
#define LONG_MAX        2147483647L
#define LONG_MIN   (-2147483647L-1)
#define ULONG_MAX      4294967295UL

/* Carl - I tweaked this for 32-bit
    The _WIDTH32_ Symbol does not exist for CPP, it's Clarion only
    So I used _WIDTH16_ which does not exist either
    So if you want to do 16-bit compiles you need to define it
    or you can create this project 1632Define.pr and add it to your projects

        -- #system defines %S as 16 or 32 so use that to define symbols for C
        #if "%S"="16" #then
          #pragma define(_WIDTH16_=>on)
        #elsif "%S"="64" #then
          #pragma define(_WIDTH64_=>on)
        #else
          #pragma define(_WIDTH32_=>on)
        #endif

*/
#ifdef _WIDTH16_
    #define INT_MAX               32767
    #define INT_MIN          (-32767-1)
    #define UINT_MAX            0xFFFFU
#else
    #define INT_MAX            LONG_MAX
    #define INT_MIN            LONG_MIN
    #define UINT_MAX           ULONG_MAX
#endif


#endif
