#include <windows.h>
#include <string.h>

/* Some C Reminders
   1 Lines end with a ;
   2 Lines end with a ;
   3 Lines end with a ;
   4 Lines end with a ;
   5 You also need curly braces {} for somethings, get a book on C
   6 Strings use double quotes ""
   7 To assign use one =, to compare use == e.g. if x == y
   8 C is CASE SENSITIVE
*/

int main()
{

    int MsgRet;
    char MsgTxt[1000] = "Hello World\0";
    strcat(MsgTxt,"\nExample of Windows GetVersionEx\n");


   OSVERSIONINFOEX osvi;
   BOOL bOsVersionInfoEx;

   // Try calling GetVersionEx using the OSVERSIONINFOEX structure.
   // If that fails, try using the OSVERSIONINFO structure.

   ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
   osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);

   if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
   {
      osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
      if (! GetVersionEx ( (OSVERSIONINFO *) &osvi) ) 
         return MessageBoxA(0,"GetVersionEx Failed" ,"Hello!",MB_OK);
   }


   ///////////////////////////////////////////////////////////////////////////////////
   // code from http://msdn.microsoft.com/library/default.asp?url=/library/en-us/sysinfo/base/getting_the_system_version.asp
    switch (osvi.dwPlatformId)
       {
          // Test for the Windows NT product family.
          case VER_PLATFORM_WIN32_NT:

             // Test for the specific product.
             if ( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 2 )
                strcat(MsgTxt,"\nMicrosoft Windows Server 2003, ");

             if ( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 1 )
                strcat(MsgTxt,"\nMicrosoft Windows XP ");

             if ( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 0 )
                strcat(MsgTxt,"\nMicrosoft Windows 2000 ");

             if ( osvi.dwMajorVersion <= 4 )
                strcat(MsgTxt, "\nMicrosoft Windows NT ");

             // Test for specific product on Windows NT 4.0 SP6 and later.
             if( bOsVersionInfoEx )
             {
                // Test for the workstation type.
                if ( osvi.wProductType == VER_NT_WORKSTATION )
                {
                   if( osvi.dwMajorVersion == 4 )
                      strcat(MsgTxt, "\nWorkstation 4.0 " );
                   else if( osvi.wSuiteMask & VER_SUITE_PERSONAL )
                      strcat(MsgTxt, "\nHome Edition " );
                   else
                      strcat(MsgTxt, "\nProfessional " );
                }
                
                // Test for the server type.
                else if ( osvi.wProductType == VER_NT_SERVER || 
                          osvi.wProductType == VER_NT_DOMAIN_CONTROLLER )
                {
                   if( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 2 )
                   {
                      if( osvi.wSuiteMask & VER_SUITE_DATACENTER )
                         strcat(MsgTxt, "\nDatacenter Edition " );
                      else if( osvi.wSuiteMask & VER_SUITE_ENTERPRISE )
                         strcat(MsgTxt, "\nEnterprise Edition " );
                      else if ( osvi.wSuiteMask == VER_SUITE_BLADE )
                         strcat(MsgTxt, "\nWeb Edition " );
                      else
                         strcat(MsgTxt, "\nStandard Edition " );
                   }

                   else if( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 0 )
                   {
                      if( osvi.wSuiteMask & VER_SUITE_DATACENTER )
                         strcat(MsgTxt, "\nDatacenter Server " );
                      else if( osvi.wSuiteMask & VER_SUITE_ENTERPRISE )
                         strcat(MsgTxt, "\nAdvanced Server " );
                      else
                         strcat(MsgTxt, "\nServer " );
                   }

                   else  // Windows NT 4.0 
                   {
                      if( osvi.wSuiteMask & VER_SUITE_ENTERPRISE )
                         strcat(MsgTxt,"\nServer 4.0, Enterprise Edition " );
                      else
                         strcat(MsgTxt, "\nServer 4.0 " );
                   }
                }
             }

             break;             

          // Test for the Windows Me/98/95.
          case VER_PLATFORM_WIN32_WINDOWS:

             if (osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 0)
             {
                 strcat(MsgTxt,"\nMicrosoft Windows 95 ");
                 if ( osvi.szCSDVersion[1] == 'C' || osvi.szCSDVersion[1] == 'B' )
                    strcat(MsgTxt,"\nOSR2 " );
             } 

             if (osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 10)
             {
                 strcat(MsgTxt,"\nMicrosoft Windows 98 ");
                 if ( osvi.szCSDVersion[1] == 'A' )
                    strcat(MsgTxt," SE " );
             } 

             if (osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 90)
             {
                 strcat(MsgTxt,"\nMicrosoft Windows Millennium Edition\n");
             } 
             break;

       }  //switch (osvi.dwPlatformId)


   ///////////////////////////////////////////////////////////////////////////////////

    //MsgTxt = "Hello World";
    MsgRet = MessageBoxA(0,MsgTxt ,"Hello!",MB_OK) ;
    return MsgRet ;
}


///////////////////////////////////////////////////////////////////
/* Jeff Slarve wrote the below and declared everything he needed inline
#define MB_OK 0x00000000L
#define MB_OKCANCEL 0x00000001L
#define MB_ABORTRETRYIGNORE 0x00000002L
#define MB_YESNOCANCEL 0x00000003L
#define MB_YESNO 0x00000004L
#define MB_RETRYCANCEL 0x00000005L


#define MB_ICONHAND 0x00000010L
#define MB_ICONQUESTION 0x00000020L
#define MB_ICONEXCLAMATION 0x00000030L
#define MB_ICONASTERISK 0x00000040L


#define MB_ICONINFORMATION MB_ICONASTERISK
#define MB_ICONSTOP MB_ICONHAND

#define MB_DEFBUTTON1 0x00000000L
#define MB_DEFBUTTON2 0x00000100L
#define MB_DEFBUTTON3 0x00000200L

#define MB_APPLMODAL    0x00000000L
#define MB_SYSTEMMODAL  0x00001000L
#define MB_TASKMODAL    0x00002000L

#define MB_NOFOCUS              0x00008000L
#define MB_SETFOREGROUND        0x00010000L
#define MB_DEFAULT_DESKTOP_ONLY 0x00020000L

typedef unsigned long HWND;
typedef char * LPCTSTR;
typedef unsigned long UINT;

int pascal MessageBoxA(
            HWND hWnd, // handle to owner window
            LPCTSTR lpText, // text in message box
            LPCTSTR lpCaption, // message box title
            UINT uType // message box style
                );
 */


// HelloMsg.cpp : Defines the entry point for the application.
//

// #include "stdafx.h"

// int APIENTRY WinMain(HINSTANCE hInstance,
//                      HINSTANCE hPrevInstance,
//                      LPSTR     lpCmdLine,
//                      int       nCmdShow)
// {
//      // TODO: Place code here.
//     MessageBox(0,"Hello World","Hello",0);
// 
//     return 0;
// }


